{ pkgs, ... }: {
  services.dunst = {
    enable = true;
    settings = {
      /* https://dunst-project.org/static/dunstrc1 */
      global = {
        follow = true;
        format = "<b>%s</b>\n%b";
        markup = "full";
        alignment = "center";
        vertical_alignment = "center";
        ignore_newline = false;
        indicate_hidden = true;
        progress_bar = true;
        word_wrap = true;
        sticky_history = true;
        mouse_left_click = "close_current";
        mouse_middle_click = "do_action, close_current";
      };
      urgency_low = {
        frame_color = "#3B7C87";
        foreground = "#3B7C87";
        background = "#191311";
      };
      urgency_normal = {
        frame_color = "#5B8234";
        foreground = "#5B8234";
        background = "#191311";
      };
      urgency_critical = {
        frame_color = "#B7472A";
        foreground = "#B7472A";
        background = "#191311";
      };
    };
  };
}
